#include <REG517A.H>

// Definicoes de S1CON (serial 1)
#define SM     0x80		// Modo de operacao da serial 1
#define SM21   0x20		// Habilita a comunicacao multiprocessador da serial 1
#define REN1   0x10		// habilita interface serial 1
#define TI1    0x02		// Interrupcao de transmissao da serial 1
#define NotTI1 0xFD
#define RI1    0x01		// Interrupcao de recepcao da serial 1
#define NotRI1 0xFE
#define SMOD   0x80

#define CLK_FREQ 		12000000		
#define BAUD 			9600					
#define RELOAD_VALUE 	( 1024 - ( ( CLK_FREQ / (32) ) / BAUD ) )

enum {OFF, ON};

///////////////////////////////////////////////////////////////////////////
// Inicializacao da interface serial
///////////////////////////////////////////////////////////////////////////
void com1_inicializaSerial()
   {
   S1RELH = RELOAD_VALUE >> 8;
   S1RELL = RELOAD_VALUE;
   S1CON = SM | REN1; // Ativa recepcao serial 1 no Modo B (8-bit), com stop bit.
   }

void sendToServer(unsigned char msg){
					
	S1BUF = msg;			// envia o dado
	while(!(S1CON & TI1));		// espera terminar de transmitir o dado
	S1CON &= NotTI1;			// resetando o TI*/
	
}

char receiveFromServer(){

	unsigned char temp = 0;
	while(!(S1CON & RI1));		// checa se o dado foi completamente recebido
	temp = S1BUF;				// copia o dado recebido para temp
	S1CON &= NotRI1;
	return temp;

}

/*void teste_ativa_desativa()
{
	unsigned char temp = 0;
	static unsigned char KEY = OFF;

		switch(KEY){
			case OFF:
				temp = receiveFromServer();
	        	if(temp == 0xC1){
					P4 = temp;
					sendToServer(0x01);
					KEY = ON;
				} else {
					P4 = 0x55;
				}
				break;
			case ON:
				temp = receiveFromServer();
				if(temp == 0xCF){
					P4 = temp;
					sendToServer(0x01);
					KEY = OFF;
				} else {
					P4 = 0xAA;
				}
				break;
		}	

}*/

void main(){
	unsigned char x = 0;
	com1_inicializaSerial();
	EAL = 1;

	P4 = x;

	while(1){

		x = receiveFromServer();
		P4 = x;
		sendToServer(x);

	}
}

